unit Spiel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jpeg, ExtCtrls, StdCtrls, Spin, Math;

type
  TTvH = class(TForm)
    Image11: TImage;
    Image12: TImage;
    Image13: TImage;
    Image16: TImage;
    Image15: TImage;
    Image14: TImage;
    Image19: TImage;
    Image18: TImage;
    Image17: TImage;
    Image1Oben: TImage;
    ImageS1: TImage;
    ImageS2: TImage;
    Image2Oben: TImage;
    Image29: TImage;
    Image28: TImage;
    Image27: TImage;
    Image26: TImage;
    Image25: TImage;
    Image24: TImage;
    Image23: TImage;
    Image22: TImage;
    Image21: TImage;
    ImageS3: TImage;
    Image3Oben: TImage;
    Image39: TImage;
    Image38: TImage;
    Image37: TImage;
    Image36: TImage;
    Image35: TImage;
    Image34: TImage;
    Image33: TImage;
    Image32: TImage;
    Image31: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LabelN: TLabel;
    SpinEditS: TSpinEdit;
    Start: TButton;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    ImagePfeiler: TImage;
    Regeln: TButton;
    Anzeige: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure SpinEditSChange(Sender: TObject);
    procedure TurmClick(Sender: TObject);
    procedure RegelnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    N,TurmVon,Count:Integer;
    Turm:Array[1..3,1..9]of Integer;    // 3 Trme mit maximal 9 Scheiben
    ScheibenZahl:Array[1..3]of Integer; // Scheibenzahl pro Turm
    ScheibenWahl,Fertig:Boolean;
    procedure TurmAusgabe;
  public
    { Public-Deklarationen }
  end;

var
  TvH: TTvH;

implementation

{$R *.dfm}
{$R+,Q+}

 const LobN=10;TadelN=10;
       Lob:Array[1..LobN]of String=('sehr gut!','fabelhaft!','wunderbar!',
                                    'ICH bin stolz auf dich!','gut gemacht!',
                                    'du hast es geschafft!','du kannst es ja!',
                                    'noch einmal so!','toll gemacht!',
                                    'feiner Zug');
       Tadel:Array[1..TadelN]of String=('ganz nett!','umsonst!','zu schlecht!',
                                        'mehr Glck das nchste Mal!',
                                        'noch einmal!','nicht aufgeben!',
                                        'wrfel noch einmal!','bemhe dich doch!!',
                                        'versuch es wieder!',
                                        'der nchste klappt bestimmt!');

 procedure TTvH.TurmAusgabe;
  var K,L:Integer;
  begin
   for K:=1 to 3 do
    for L:=1 to 9 do
     if Turm[K,L]=0 then
      TImage(FindComponent('Image'+IntToStr(K)+IntToStr(L))).Picture:=ImagePfeiler.Picture
     else TImage(FindComponent('Image'+IntToStr(K)+IntToStr(L))).Picture:=TImage(FindComponent('Image'+IntToStr(N+1-Turm[K,L]))).Picture
  end;

 procedure TTvH.FormCreate(Sender: TObject);
  var K,L:Integer;
  begin
   ScheibenWahl:=False;
   N:=SpinEditS.Value;
   Count:=0;
   Anzeige.Text:='whle eine Scheibe';
   for K:=1 to 3 do
    begin
     ScheibenZahl[K]:=0;
     for L:=1 to 9 do Turm[K,L]:=0; // Trme leeren
    end;
   for K:=1 to N do Turm[1,K]:=K;
   ScheibenZahl[1]:=N; // 1. Turm
   Color:=$00FE5500; // Palette = 0, Blau = 254($FE), Grn = 85($55), Rot = 0
   TurmAusgabe;
   Fertig:=False;
  end;

 procedure TTvH.StartClick(Sender: TObject);
  var K,L:Integer;
  begin
   N:=SpinEditS.Value;
   Count:=0;
   Fertig:=False;
   Anzeige.Text:='whle eine Scheibe';
   ScheibenWahl:=False;
   for K:=1 to 3 do
    begin
     ScheibenZahl[K]:=0;
     for L:=1 to 9 do Turm[K,L]:=0; // Trme leeren
    end;
   for K:=1 to N do Turm[1,K]:=K;
   ScheibenZahl[1]:=N; // 1. Turm
   TurmAusgabe;
  end;

 procedure TTvH.SpinEditSChange(Sender: TObject);
  begin
   if SpinEditS.Text='' then SpinEditS.Value:=3;
  end;

 procedure TTvH.TurmClick(Sender: TObject);
  var K,L,T,S,Teil:Integer;
      Info:String;
  begin
   if Fertig then
    begin
     MessageDlg('Du mut mit Transport beginnen!',mtError,[mbRetry],0);
     exit;
    end;
   for K:=1 to 3 do
    for L:=1 to 9 do
     if Sender=TImage(FindComponent('Image'+IntToStr(K)+IntToStr(L))) then
      begin T:=K;S:=L end; // Turmnummer, Scheibennummer
   if Turm[T,S]=0 then // Turm angewhlt
    begin
     if not ScheibenWahl then
      begin
       MessageDlg('Du mut erst eine Scheibe whlen!',mtError,[mbRetry],0);
       exit;
      end;
     Teil:=Turm[TurmVon,ScheibenZahl[TurmVon]];
     // pat die Scheibe?
     if ScheibenZahl[T]>0 then
      if Teil<Turm[T,ScheibenZahl[T]] then
       begin
        MessageDlg('Die Scheibe darf NICHT auf eine kleinere gelegt werden!',mtError,[mbRetry],0);
        exit;
       end;
     // Scheibe verschieben
     Turm[TurmVon,ScheibenZahl[TurmVon]]:=0; // Scheibe runter
     dec(ScheibenZahl[TurmVon]);
     inc(ScheibenZahl[T]);
     Turm[T,ScheibenZahl[T]]:=Teil; // Scheibe rauf
     TurmAusgabe;
     inc(Count);
     ScheibenWahl:=False;
     if ScheibenZahl[3]=N then
      begin
       Fertig:=True;
       Anzeige.Text:='Du hast es geschafft, '+Lob[random(LobN)+1];
       Info:='Du brauchtest '+IntToStr(Count)+' Zge!'+#13;
       if Count=Power(2,N)-1 then Info:=Info+'optimale Lsung, Super - Denker!!!'
       else Info:=Info+Lob[random(LobN)+1];
       MessageDlg(Info,mtInformation,[mbOk],0);
      end
     else if (ScheibenZahl[1]=N) or (ScheibenZahl[2]=N) then
      begin
       Anzeige.Text:='Schade, '+Tadel[random(TadelN)+1];;
       Info:='Du hast es zwar geschafft,'+#13+
             'leider liegen die Scheiben NICHT auf Turm 3'+#13+
             'versuche es weiter, gib NICHT auf!';
       MessageDlg(Info,mtInformation,[mbOk],0);
      end
     else Anzeige.Text:='whle eine Scheibe';
    end
   else // Scheibe angewhlt
    begin
     if ScheibenWahl then
      begin
       MessageDlg('Du solltest einen Turm whlen!'+#13+'Fang von vorne an!',mtError,[mbOk],0);
       ScheibenWahl:=False;
       Anzeige.Text:='whle eine Scheibe';
       exit;
      end;
     if S<>ScheibenZahl[T] then
      begin
       MessageDlg('Du mut eine kleinere Scheibe whlen!',mtError,[mbRetry],0);
       exit;
      end;
     ScheibenWahl:=True;
     TurmVon:=T;
     Anzeige.Text:='whle einen Turm';
    end
  end;

 procedure TTvH.RegelnClick(Sender: TObject);
  var Info:String;
  begin
   Info:='Du mut den Stapel von Turm 1 nach Turm 3 transportieren'+#13;
   Info:=Info+'Ziel des Spiels ist es, den kompletten Stapel von'+#13;
   Info:=Info+'Turm 1 nach Turm 3 zu versetzen. Bei jedem Zug darf'+#13;
   Info:=Info+'die oberste Scheibe eines beliebigen Turmes auf'+#13;
   Info:=Info+'einen der beiden anderen Trme gelegt werden,'+#13;
   Info:=Info+'vorausgesetzt,dort liegt nicht schon eine kleinere Scheibe.';
   MessageDlg(Info,mtInformation,[mbOk],0);
  end;

end.

